<script>
  import Social from "./social.svelte";

  export let src;
  export let thumbShow;

  let cls = "";

  const open = e => {
    e.preventDefault();
    cls = "show";
    document.body.style.overflow = "hidden";
    return false;
  };

  const close = e => {
    document.body.style.overflow = "";
    cls = "";
  };
</script>

<style>
  #cta {
    display: grid;
    grid-template-columns: minmax(300px, 420px) minmax(180px, 1fr);
    grid-gap: 30px;

    box-sizing: border-box;
    margin-bottom: 20px;
  }

  h2 {
    font-size: 25px;
    margin: 0 0 5px;
    width: 100%;
  }

  .content {
    min-width: 180px;
    display: flex;
    flex-flow: row wrap;
    justify-content: flex-start;
    align-items: flex-start;
  }

  .button {
    width: 100%;
    margin-bottom: 10px;
    text-align: center;
  }

  #popup {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    width: 100%;
    max-width: 400px;
    max-height: 80vh;
    z-index: 1;

    overflow: scroll;
    border-radius: 10px;

    display: none;
  }

  #video {
    background: url("img/give-thumb.jpg");
    background-position: center;
    background-size: cover;
    position: relative;
  }

  #video::before {
    position: absolute;
    content: "";
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    background-image: url("./img/play-button.svg");
    background-position: center;
    background-size: contain;
    width: 50px;
    height: 50px;
    text-align: center;
    display: flex;
    justify-content: center;
    align-items: center;
    opacity: 1;
    transition: opacity 400ms;
    cursor: pointer;
    z-index: 1;
  }

  #video::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    cursor: pointer;
  }

  #video.load {
    background: #222a2f;
  }

  #video.load::before,
  #video.load::after {
    animation: fade 400ms forwards;
  }

  @keyframes fade {
    0% {
      opacity: 1;
    }
    99% {
      opacity: 0;
    }
    100% {
      opacity: 0;
      visibility: hidden;
    }
  }

  iframe {
    width: 100%;
  }

  #popup.show {
    display: block;
  }

  #popup.show ~ .overlay {
    display: block;
  }

  .close {
    font-weight: 900;
    position: sticky;
    top: 0;
    left: 0;
    background: #ffffffaa;
    width: 20px;
    height: 20px;
    margin-top: -20px;
    border-radius: 50%;
    cursor: pointer;
  }

  .close::before,
  .close::after {
    position: absolute;
    content: "";
    display: block;
    width: 3px;
    height: 10px;
    background: #000;

    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) rotate(-45deg);
  }

  .close::after {
    transform: translate(-50%, -50%) rotate(45deg);
  }

  .overlay {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: #000000aa;
    display: none;
  }

  #share-buttons {
    max-width: 140px;
    display: flex;
    flex-flow: row wrap;
    justify-content: flex-start;
    align-items: flex-start;
  }

  @media (max-width: 1175px) {
    #cta {
      grid-template-columns: 1fr;
    }

    .content {
      justify-content: center;
    }

    h2 {
      text-align: center;
    }
    .button {
      flex-grow: 1;
      max-width: 300px;
      margin: 10px 0;
    }

    #share-buttons {
      flex-grow: 1;
      justify-content: center;
      max-width: unset;
      width: 100%;
    }
  }

  @media (max-width: 900px) {
    h2 {
      text-align: center;
    }
    .button {
      width: 100%;
      text-align: center;
      margin: 10px 0;
    }

    #share-buttons {
      margin: auto;
    }

    #video {
      height: 350px;
      max-height: calc((100vw - 80px) * 9 / 16);
    }

    iframe {
      height: 100%;
    }
  }
</style>

<section id="cta">
  <div id="video" class={thumbShow} on:click>
    <iframe
      width="420"
      height="236"
      {src}
      frameborder="0"
      allow="accelerometer; autoplay; encrypted-media; gyroscope;"
      title=""
      autoplay
      allowfullscreen />
  </div>
  <div class="content">
    <h2>Join Our Fight. Save Lives.</h2>
    <a
      on:click={open}
      href="https://secure.givelively.org/donate/wildwood-sanitarium-incorporated/giving-tuesday"
      target="_blank"
      class="button">
      Donate
    </a>
    <div id="share-buttons">
      <Social />
    </div>
  </div>

  <div id="popup" class={cls}>
    <div class="close" on:click={close} />
    <!-- Begin Give Lively Fundraising Widget -->
    <script>
      gl = document.createElement("script");
      gl.src =
        "https://secure.givelively.org/widgets/branded_donation/wildwood-sanitarium-incorporated/giving-tuesday.js";
      document.getElementsByTagName("head")[0].appendChild(gl);
    </script>
    <div
      data-widget-src="https://secure.givelively.org/donate/wildwood-sanitarium-incorporated/giving-tuesday?ref=sd_widget"
      id="give-lively-widget"
      class="gl-branded-donation-widget" />
    <!-- End Give Lively Fundraising Widget -->
  </div>
  <div class="overlay" on:click={close} />
</section>
